AWSTemplateFormatVersion: '2010-09-09'
Transform: 'AWS::Serverless-2016-10-31'

Resources:

  GenerateJWTFunction:
    Type: AWS::Serverless::Function
    Properties:
      Handler: handler.generateJWT
      CodeUri: ./generateJWT
      Runtime: nodejs16.x
      Events:
        GenerateJWTApi:
          Type: Api
          Properties:
            RestApiId: !Ref JWTApi
            Path: /generateJWT
            Method: POST
 

  JWTApi:
    Type: AWS::Serverless::Api
    Properties:
      StageName: Prod
      DefinitionBody:
        swagger: '2.0'
        paths:
          /generateJWT:
            post:
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${GenerateJWTFunction.Arn}/invocations
                passthroughBehavior: when_no_match
                httpMethod: POST
                type: aws_proxy          

Outputs:

  GenerateJWTFunctionApi:
    Description: "API Gateway endpoint URL for Generate JWT function"
    Value: !Sub "https://${JWTApi}.execute-api.${AWS::Region}.amazonaws.com/Prod/generateJWT"


  JWTApiId:
    Description: "API Gateway ID"
    Value: !Ref JWTApi
